<html>
<!--

  Arkanon <arkanon@klsd.org.br>
  2018/10/21 (Sun) 03:03:29 -03
  2018/10/20 (Sat) 21:47:13 -03
  2018/10/19 (Fri) 21:09:26 -03
  2013/07/14 (Sun) 16:22:15 -03 - v0.3
  2013/05/03 (Fri) 04:09:43 -03 - v0.2
  2013/04/19 (Fri) 02:08:11 -03 - v0.1

-->
<head>
  <meta charset="utf-8">
  <script>

    var body, marginTop, marginRight, marginBottom, marginLeft;
    var canvas, canvas_id, context, dataset, row, col, N, M, m, Cr, Ci, ins;
    var gradient, mandelcor, sqmodlim, Z0r, Z0i, W, H, I, S, O, L, R;

    function rq (x) { return Math.sqrt (x) }
    function sen(x) { return Math.sin  (x) }
    function cos(x) { return Math.cos  (x) }
    function tg (x) { return sen(x)/cos(x) }
    function ln (x) { return Math.log  (x) }
    function abs(x) { return Math.abs  (x) }

    var fi = (rq(5)+1)/2;
    var pi = 4*Math.atan(1);
    var one_over_log2 = 1/ln(2);

    window.onload = function()
    {

      mandelcor = [0, 0, 0];
       sqmodlim = 4;
            Z0r = 0;
            Z0i = 0;

      canvas_id    = 'plano';

      body         = document.getElementsByTagName('body')[0];
      marginTop    = computed('margin-top'   );
      marginRight  = computed('margin-right' );
      marginBottom = computed('margin-bottom');
      marginLeft   = computed('margin-left'  );

      I = 3000;
   // O = [ 0 , 0 ];

   // S = 1;
   // W = 500;
   // H = 500;
   // L = [ -2.010 , -2.01000 ]; R = [  2.010 , 2.01000 ];
   // L = [ -1.944 , -0.00200 ]; R = [ -1.939 , 0.00200 ];
      L = [ -1.944 , -0.00124 ]; R = [ -1.939 , 0.00124 ];

      W = window.innerWidth  - ( marginLeft + marginRight  );
   // H = window.innerHeight - ( marginTop  + marginBottom );
   // S = 2 * Math.sqrt(sqmodlim) / (H>W?W:H);
   // L = [ O[0] - S*W/2 , O[1] - S*H/2 ];
   // R = [ O[0] + S*W/2 , O[1] + S*H/2 ];

      if ( H === undefined )
      {
        S = (R[0]-L[0])/W;
        H = W*(R[1]-L[1])/(R[0]-L[0]);
      }
      else
      {
        S = (R[0]-L[0])/H;
        W = H*(R[1]-L[1])/(R[0]-L[0]);
      }

      canvas        = document.getElementById(canvas_id);
      canvas.width  = W;
      canvas.height = H;
      context       =  canvas.getContext('2d');
      dataset       = context.getImageData(0, 0, W, H);

      // <http://colorzilla.com/gradient-editor>
   // gradient = [
   //              [ [ 255, 255, 255 ],   0 ],
   //              [ [   1,  15, 170 ],  20 ],
   //              [ [  26, 193,  23 ],  40 ],
   //              [ [ 240, 244,   2 ],  60 ],
   //              [ [ 117,  34,   1 ],  80 ],
   //              [ [   0,   0,   0 ], 100 ],
   //            ];

      gradient = [
                   [ [ 127, 127, 127 ],    0 ],
                   [ [   0,  64,   0 ],   20 ],
                   [ [   0,   0,   0 ],   50 ],
                   [ [ 153,   0,   0 ],   85 ],
                   [ [ 239, 182,  47 ],  200 ],
                   [ [   0,   0,   0 ], 1500 ],
                 ];

      row = 0;
      Ci  = R[1];

      mainloop();

    }



    function mainloop()
    {
      var cor;
      col = 0;
      for (Cr=L[0]; Cr<=R[0]; Cr+=S)
      {
        ins = inSet(Cr, Ci, I, sqmodlim);
          M = Math.sqrt(ins[1]);
          m = Math.sqrt(ins[2]);
          N =           ins[3];

        // <http://stackoverflow.com/a/25816111>
        // Based on <http://jsfiddle.net/vksn3yLL> from <http://stackoverflow.com/a/30144587>
        //  <http://jsfiddle.net/arkanon/vksn3yLL/1328>     interactive
        //  <http://jsfiddle.net/arkanon/vksn3yLL/1316> non-interactive
        var slider        = N;
        var colorRange = [ gradient.length-2, gradient.length-1 ];
        for ( var index in gradient ) if ( slider <= gradient[index][1] ) { colorRange = [ index-1, index ]; break }

        // get the two closest colors
        var firstcolor    = gradient[colorRange[0]][0];
        var secondcolor   = gradient[colorRange[1]][0];

        // calculate ratio between the two closest colors
        var firstcolor_x  = gradient[colorRange[0]][1]/100;
        var secondcolor_x = gradient[colorRange[1]][1]/100 - firstcolor_x;
        var slider_x      = slider/100                     - firstcolor_x;
        var ratio         = slider_x/secondcolor_x;

            cor           = ( ins[0] || N==1 ) ? mandelcor : pickHex( secondcolor, firstcolor, ratio );

        plotpix(row, col, cor);
        col++;
      }
      Ci -= S;
      row++;
      context.putImageData(dataset, 0, 0);
      if ( Ci>=L[1] ) setZeroTimeout(mainloop);
    }



    function  inSet(Cr, Ci, I, sqmodlim)
    {
      var tmp, znr, zni, znm2, n;
      znr = Z0r;
      zni = Z0i;
      for (n=1; n<=I; n++)
      {

        // <http://maxima.cesga.es>

        // z²+c
        tmp  = 2*znr*zni + Ci;
        znr  = znr*znr - zni*zni + Cr;

     // // z³+c
     // tmp  = 3*znr*znr*zni - zni*zni*zni + Ci;
     // znr  = znr*znr*znr - 3*znr*zni*zni + Cr;

     // // z⁴+c
     // tmp  = 4*(znr*znr*znr*zni - zni*zni*zni*znr) + Ci;
     // znr  = znr*znr*znr*znr - 6*znr*znr*zni*zni + zni*zni*zni*zni + Cr;

     // // z³+z²+c
     // tmp  = ( 3*znr*znr*zni - zni*zni*zni ) + ( 2*znr*zni ) + Ci;
     // znr  = ( znr*znr*znr - 3*znr*zni*zni ) + ( znr*znr - zni*zni ) + Cr;

     // // z⁴+z²+c
     // tmp  = 4*(znr*znr*znr*zni - zni*zni*zni*znr) + ( 2*znr*zni ) + Ci;
     // znr  = ( znr*znr*znr*znr - 6*znr*znr*zni*zni + zni*zni*zni*zni ) + ( znr*znr - zni*zni ) + Cr;

     // // z⁴+z³+c
     // tmp  = 4*(znr*znr*znr*zni - zni*zni*zni*znr) + ( 3*znr*znr*zni - zni*zni*zni ) + Ci;
     // znr  = ( znr*znr*znr*znr - 6*znr*znr*zni*zni + zni*zni*zni*zni ) + ( znr*znr*znr - 3*znr*zni*zni ) + Cr;

     // // z⁴+z³+z²+c
     // tmp  = 4*(znr*znr*znr*zni - zni*zni*zni*znr) + ( 3*znr*znr*zni - zni*zni*zni ) + ( 2*znr*zni ) + Ci;
     // znr  = ( znr*znr*znr*znr - 6*znr*znr*zni*zni + zni*zni*zni*zni ) + ( znr*znr*znr - 3*znr*zni*zni ) + ( znr*znr - zni*zni ) + Cr;

        zni  = tmp;
        znm2 = znr*znr + zni*zni;
        cm2  = Cr*Cr + Ci*Ci;
        if (znm2 >= sqmodlim) return [false, znm2, cm2, n];
      }
      return [true, znm2, cm2];
    }



    function plotpix(row, col, cor)
    {
      var i = ( row * W + col )*4;
      dataset.data[i+0] = cor[0];
      dataset.data[i+1] = cor[1];
      dataset.data[i+2] = cor[2];
      dataset.data[i+3] = 255;
    }



    function pickHex(color1, color2, weight)
    {
      var p   = weight;
      var w   = 2*p - 1;
      var w1  = (w+1)/2;
      var w2  = 1 - w1;
      var rgb = [
                  Math.round( w1*color1[0] + w2*color2[0] ),
                  Math.round( w1*color1[1] + w2*color2[1] ),
                  Math.round( w1*color1[2] + w2*color2[2] ),
                ];
      return rgb;
    }



    function computed(prop)
    {
      return parseFloat(window.getComputedStyle(body).getPropertyValue(prop));
    }



    // setZeroTimeout <http://dbaron.org/log/20100309-faster-timeouts>
    (

      // add only to the window object, and hide everything else in a closure.

      function()
      {

        var timeouts = [];
        var messageName = "zero-timeout-message";

        // Like setTimeout, but only takes a function argument. There's no time argument
        // (always zero) and no arguments (you have to use a closure).
        function setZeroTimeout(fn)
        {
          timeouts.push(fn);
          window.postMessage(messageName, "*");
        }

        function handleMessage(event)
        {
          if (event.source == window && event.data == messageName)
          {
            event.stopPropagation();
            if (timeouts.length > 0)
            {
              var fn = timeouts.shift();
              fn();
            }
          }
        }

        window.addEventListener("message", handleMessage, true);

        // Add the one thing we want added to the window object.
        window.setZeroTimeout = setZeroTimeout;

      }

    )();



  </script>
  <style>
    body   { margin: 0; background: black }
    canvas { margin: auto; display: block }
  </style>
</head>
<body><canvas id="plano"></canvas></body>
</html>
